#! /usr/local/bin/perl
# Copyright (C) 2009 OKADA Hitoshi
# Perl5
#
# ꤷCE3ޤLB3եʤΥԥֹޤȤɽɽˤޤ
#
#  perl hidePinNum.pl  [-H][-D] datafile[Enter]
#
# datafileBSch3VޤLCoVΥǡǤĥҤCE3ޤLB3ǤʤФʤޤ
#


# ޥɥ饤β
($targetFile,$hideMode) = &parseCmdLine();

# åȥե뤬.ce3.lb3ǤʤСusageåϤƽλ
if($targetFile !~ /\.ce3$/i && $targetFile !~ /\.lb3$/i ){
	print "USAGE: perl hidePinNum.pl [-H][-D] datafile[Enter]\n";
	print "   -H (Default) - Hide Pin Number\n";
	print "   -D           - Display Pin Number\n";
	print "   datafile     - BSch3V schematic data or LCoV component library data\n";
	exit(255);
}

if($hideMode != 0){
	$modeMsg = "Hide Pin Number\n";
}else{
	$modeMsg = "Display Pin Number\n";
}

printf("Target file: %s\n",$targetFile);
printf("Mode:        %s\n",$modeMsg);


$outfile = $targetFile;
$srcfile = $targetFile."\$";

#ե̾ѹƥХååפȤ
if((rename $outfile, $srcfile) == 0){
	die "Backup error.\n";
}

#եΥץ
open(IN,$srcfile) || die "ERROR open source file :$srcfile\n";
open(OUT,">".$outfile) || die "ERROR open destination file :$outfile\n";

$ce3init = 1;
$readlib = 0;
$readpin = 0;


while(1){
	($ce3rec,$getce3stus) = getCE3Record(*IN,$ce3init);
	$ce3init = 0;
	if($getce3stus == -1){
		last;
	}
	
	if($getce3stus==0){
		$delim = ",";
	}else{
		$delim = "\n";
	}

	if($readlib == 1){
		if($ce3rec =~ /^\-BSCH3\_LIB\_V/){
			$readlib = 0;
			$readpin = 0;
		}else{
			if($readpin == 1){	# ԥǡν
				if($ce3rec eq "-PIN"){
					$readpin = 0;
				}else{
					if($ce3rec =~ /^T:/){
						$pinstatus = substr($ce3rec,2);
						if($hideMode != 0){
							if($pinstatus !~ /m/){
								$pinstatus = $pinstatus."m";
							}
						}else{
							$pinstatus =~ s/m//;
						}
						$ce3rec = "T:".$pinstatus;
					}
				}
			}else{
				if($ce3rec eq "+PIN"){
					$readpin = 1;
				}
			}
		}
	}elsif($ce3rec =~ /^\+BSCH3\_LIB\_V/){
		$readlib = 1;
		$readpin = 0;
	}

	print OUT $ce3rec.$delim;
}

close IN;
close OUT;

exit(0);

###########################################################################
# ޥɥ饤β
sub parseCmdLine {
	my($targetFile,$hideMode,$argc,$n);
	
	$targetFile = "";
	$hideMode = 1;

	$argc = @ARGV; 
	if($argc>0){
		for($n = 0; $n<$argc; $n++){
			if($ARGV[$n] eq "-H"){
				$hideMode = 1;
			}elsif($ARGV[$n] eq "-D"){
				$hideMode = 0;
			}else{
				$targetFile = $ARGV[$n];
			}
		}
	}
	return ($targetFile,$hideMode);
}

	


##############################################################
# CE3ե뤫顢쥳ɤڤФ
BEGIN{
	my($line,@recarray,$reccount,$index,$retrec);
	$index = 0;		#1(index)ܤΥ쥳ɤ򤳤줫롣
	$reccount = 0;	#1Υ쥳ɤο
	sub getCE3Record {
		local(*readfile, $init) = @_;
		my($line,$retrec,$status);
		
		if($init!=0 || $index == $reccount){
			$index = 0;
		}
		
		if($index==0){
			while(1){
				if($line=<readfile>){
				    chomp($line);                   #βԤκ
					@recarray = &splitce3($line);	#뤴Ȥʬ
		    		$reccount = @recarray;
				}else{
					return("",-1);
				}
				if($reccount>0){
					last;
				}
			}
		}
		$retrec = $recarray[$index];
		$retrec =~ s/^\s*(\S+)\s*$/$1/g;			#ξüζκ
		$index = $index + 1;
		if($index == $reccount){
			$status = 1;
		}else{
			$status = 0;
		}
		return ($retrec,$status);
	}
}

###########################################################################
# CE3ԤΥץåȤԤ֥롼
sub splitce3 {
    my($ce3str) = @_;
    my(@splitdata,$recdata);
    $ce3str .= ',';  							# ԤκǸˡ,פղä
    @splitdata= split(/,/, $ce3str);			# CE3ե,ǥץåȤǤ
    return @splitdata;
}


